libnl: Inet Diag Messages

libnl 3.12.0

Inet Diag Messages
Inet Diag library (libnl-idiag)

## Functions
struct idiagnl_msg * | idiagnl_msg_alloc (void)
void | idiagnl_msg_get (struct idiagnl_msg *msg)
void | idiagnl_msg_put (struct idiagnl_msg *msg)
int | idiagnl_msg_parse (struct nlmsghdr *nlh, struct idiagnl_msg **result)

## Cache Management
int | idiagnl_msg_alloc_cache (struct nl_sock *sk, int family, int states, struct nl_cache **result)
| Build an inetdiag cache to hold socket state information.

## Attributes
uint8_t | idiagnl_msg_get_family (const struct idiagnl_msg *msg)
void | idiagnl_msg_set_family (struct idiagnl_msg *msg, uint8_t family)
uint8_t | idiagnl_msg_get_state (const struct idiagnl_msg *msg)
void | idiagnl_msg_set_state (struct idiagnl_msg *msg, uint8_t state)
uint8_t | idiagnl_msg_get_timer (const struct idiagnl_msg *msg)
void | idiagnl_msg_set_timer (struct idiagnl_msg *msg, uint8_t timer)
uint8_t | idiagnl_msg_get_retrans (const struct idiagnl_msg *msg)
void | idiagnl_msg_set_retrans (struct idiagnl_msg *msg, uint8_t retrans)
uint16_t | idiagnl_msg_get_sport (struct idiagnl_msg *msg)
void | idiagnl_msg_set_sport (struct idiagnl_msg *msg, uint16_t port)
uint16_t | idiagnl_msg_get_dport (struct idiagnl_msg *msg)
void | idiagnl_msg_set_dport (struct idiagnl_msg *msg, uint16_t port)
struct nl_addr * | idiagnl_msg_get_src (const struct idiagnl_msg *msg)
int | idiagnl_msg_set_src (struct idiagnl_msg *msg, struct nl_addr *addr)
struct nl_addr * | idiagnl_msg_get_dst (const struct idiagnl_msg *msg)
int | idiagnl_msg_set_dst (struct idiagnl_msg *msg, struct nl_addr *addr)
uint32_t | idiagnl_msg_get_ifindex (const struct idiagnl_msg *msg)
void | idiagnl_msg_set_ifindex (struct idiagnl_msg *msg, uint32_t ifindex)
uint32_t | idiagnl_msg_get_expires (const struct idiagnl_msg *msg)
void | idiagnl_msg_set_expires (struct idiagnl_msg *msg, uint32_t expires)
uint32_t | idiagnl_msg_get_rqueue (const struct idiagnl_msg *msg)
void | idiagnl_msg_set_rqueue (struct idiagnl_msg *msg, uint32_t rqueue)
uint32_t | idiagnl_msg_get_wqueue (const struct idiagnl_msg *msg)
void | idiagnl_msg_set_wqueue (struct idiagnl_msg *msg, uint32_t wqueue)
uint32_t | idiagnl_msg_get_uid (const struct idiagnl_msg *msg)
void | idiagnl_msg_set_uid (struct idiagnl_msg *msg, uint32_t uid)
uint32_t | idiagnl_msg_get_inode (const struct idiagnl_msg *msg)
void | idiagnl_msg_set_inode (struct idiagnl_msg *msg, uint32_t inode)
uint8_t | idiagnl_msg_get_tos (const struct idiagnl_msg *msg)
void | idiagnl_msg_set_tos (struct idiagnl_msg *msg, uint8_t tos)
uint8_t | idiagnl_msg_get_tclass (const struct idiagnl_msg *msg)
void | idiagnl_msg_set_tclass (struct idiagnl_msg *msg, uint8_t tclass)
uint8_t | idiagnl_msg_get_shutdown (const struct idiagnl_msg *msg)
void | idiagnl_msg_set_shutdown (struct idiagnl_msg *msg, uint8_t shutdown)
char * | idiagnl_msg_get_cong (const struct idiagnl_msg *msg)
void | idiagnl_msg_set_cong (struct idiagnl_msg *msg, char *cong)
struct idiagnl_meminfo * | idiagnl_msg_get_meminfo (const struct idiagnl_msg *msg)
void | idiagnl_msg_set_meminfo (struct idiagnl_msg *msg, struct idiagnl_meminfo *minfo)
struct idiagnl_vegasinfo * | idiagnl_msg_get_vegasinfo (const struct idiagnl_msg *msg)
void | idiagnl_msg_set_vegasinfo (struct idiagnl_msg *msg, struct idiagnl_vegasinfo *vinfo)
struct tcp_info | idiagnl_msg_get_tcpinfo (const struct idiagnl_msg *msg)
void | idiagnl_msg_set_tcpinfo (struct idiagnl_msg *msg, struct tcp_info *tinfo)

## Detailed Description

Inet Diag Message Documentation (Netlink Inet Diag Development Guide)

## Function Documentation

## ◆ idiagnl_msg_alloc()

struct idiagnl_msg * idiagnl_msg_alloc | ( | void |  | ) |

Definition at line 84 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get()

void idiagnl_msg_get | ( | struct idiagnl_msg * | msg | ) |

Definition at line 89 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_put()

void idiagnl_msg_put | ( | struct idiagnl_msg * | msg | ) |

Definition at line 94 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_alloc_cache()

int idiagnl_msg_alloc_cache | ( | struct nl_sock * | sk,
|  | int | family,
|  | int | states,
|  | struct nl_cache ** | result )

Build an inetdiag cache to hold socket state information.

Parameters

  sk | Netlink socket
  family | The address family to query
  states | Socket states to query
  result | Result pointer

Note
  The caller is responsible for destroying and free the cache after using it.

Returns
  0 on success of a negative error code.

Definition at line 174 of file idiag_msg_obj.c.

References nl_cache_alloc(), and nl_cache_refill().

Here is the call graph for this function:

## ◆ idiagnl_msg_get_family()

uint8_t idiagnl_msg_get_family | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 202 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_family()

void idiagnl_msg_set_family | ( | struct idiagnl_msg * | msg,
|  | uint8_t | family )

Definition at line 207 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_state()

uint8_t idiagnl_msg_get_state | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 213 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_state()

void idiagnl_msg_set_state | ( | struct idiagnl_msg * | msg,
|  | uint8_t | state )

Definition at line 218 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_timer()

uint8_t idiagnl_msg_get_timer | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 224 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_timer()

void idiagnl_msg_set_timer | ( | struct idiagnl_msg * | msg,
|  | uint8_t | timer )

Definition at line 229 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_retrans()

uint8_t idiagnl_msg_get_retrans | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 235 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_retrans()

void idiagnl_msg_set_retrans | ( | struct idiagnl_msg * | msg,
|  | uint8_t | retrans )

Definition at line 240 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_sport()

uint16_t idiagnl_msg_get_sport | ( | struct idiagnl_msg * | msg | ) |

Definition at line 246 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_sport()

void idiagnl_msg_set_sport | ( | struct idiagnl_msg * | msg,
|  | uint16_t | port )

Definition at line 251 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_dport()

uint16_t idiagnl_msg_get_dport | ( | struct idiagnl_msg * | msg | ) |

Definition at line 257 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_dport()

void idiagnl_msg_set_dport | ( | struct idiagnl_msg * | msg,
|  | uint16_t | port )

Definition at line 262 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_src()

struct nl_addr * idiagnl_msg_get_src | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 268 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_src()

int idiagnl_msg_set_src | ( | struct idiagnl_msg * | msg,
|  | struct nl_addr * | addr )

Definition at line 273 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_dst()

struct nl_addr * idiagnl_msg_get_dst | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 285 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_dst()

int idiagnl_msg_set_dst | ( | struct idiagnl_msg * | msg,
|  | struct nl_addr * | addr )

Definition at line 290 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_ifindex()

uint32_t idiagnl_msg_get_ifindex | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 302 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_ifindex()

void idiagnl_msg_set_ifindex | ( | struct idiagnl_msg * | msg,
|  | uint32_t | ifindex )

Definition at line 307 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_expires()

uint32_t idiagnl_msg_get_expires | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 313 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_expires()

void idiagnl_msg_set_expires | ( | struct idiagnl_msg * | msg,
|  | uint32_t | expires )

Definition at line 318 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_rqueue()

uint32_t idiagnl_msg_get_rqueue | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 324 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_rqueue()

void idiagnl_msg_set_rqueue | ( | struct idiagnl_msg * | msg,
|  | uint32_t | rqueue )

Definition at line 329 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_wqueue()

uint32_t idiagnl_msg_get_wqueue | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 335 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_wqueue()

void idiagnl_msg_set_wqueue | ( | struct idiagnl_msg * | msg,
|  | uint32_t | wqueue )

Definition at line 340 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_uid()

uint32_t idiagnl_msg_get_uid | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 346 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_uid()

void idiagnl_msg_set_uid | ( | struct idiagnl_msg * | msg,
|  | uint32_t | uid )

Definition at line 351 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_inode()

uint32_t idiagnl_msg_get_inode | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 357 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_inode()

void idiagnl_msg_set_inode | ( | struct idiagnl_msg * | msg,
|  | uint32_t | inode )

Definition at line 362 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_tos()

uint8_t idiagnl_msg_get_tos | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 368 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_tos()

void idiagnl_msg_set_tos | ( | struct idiagnl_msg * | msg,
|  | uint8_t | tos )

Definition at line 373 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_tclass()

uint8_t idiagnl_msg_get_tclass | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 379 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_tclass()

void idiagnl_msg_set_tclass | ( | struct idiagnl_msg * | msg,
|  | uint8_t | tclass )

Definition at line 384 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_shutdown()

uint8_t idiagnl_msg_get_shutdown | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 390 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_shutdown()

void idiagnl_msg_set_shutdown | ( | struct idiagnl_msg * | msg,
|  | uint8_t | shutdown )

Definition at line 395 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_cong()

char * idiagnl_msg_get_cong | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 401 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_cong()

void idiagnl_msg_set_cong | ( | struct idiagnl_msg * | msg,
|  | char * | cong )

Definition at line 406 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_meminfo()

struct idiagnl_meminfo * idiagnl_msg_get_meminfo | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 413 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_meminfo()

void idiagnl_msg_set_meminfo | ( | struct idiagnl_msg * | msg,
|  | struct idiagnl_meminfo * | minfo )

Definition at line 418 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_vegasinfo()

struct idiagnl_vegasinfo * idiagnl_msg_get_vegasinfo | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 428 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_vegasinfo()

void idiagnl_msg_set_vegasinfo | ( | struct idiagnl_msg * | msg,
|  | struct idiagnl_vegasinfo * | vinfo )

Definition at line 433 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_get_tcpinfo()

struct tcp_info idiagnl_msg_get_tcpinfo | ( | const struct idiagnl_msg * | msg | ) |

Definition at line 443 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_set_tcpinfo()

void idiagnl_msg_set_tcpinfo | ( | struct idiagnl_msg * | msg,
|  | struct tcp_info * | tinfo )

Definition at line 448 of file idiag_msg_obj.c.

## ◆ idiagnl_msg_parse()

int idiagnl_msg_parse | ( | struct nlmsghdr * | nlh,
|  | struct idiagnl_msg ** | result )

Definition at line 716 of file idiag_msg_obj.c.